<?xml version='1.0' encoding='UTF-8'?>
<web-app xmlns="http://java.sun.com/xml/ns/javaee" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://java.sun.com/xml/ns/javaee http://java.sun.com/xml/ns/javaee/web-app_3_0.xsd" version="3.0">
    <!-- RichFaces -->
    <context-param>
        <param-name>org.richfaces.skin</param-name>
        <param-value>plain</param-value>
    </context-param>
    <context-param>
        <param-name>javax.faces.FACELETS_LIBRARIES</param-name>
        <param-value>/WEB-INF/classes/META-INF/gazelle.taglib.xml</param-value>
    </context-param>
    <!-- Suppress spurious stylesheets -->
    <context-param>
        <param-name>org.richfaces.enableControlSkinning</param-name>
        <param-value>false</param-value>
    </context-param>
    <context-param>
        <param-name>org.richfaces.enableControlSkinningClasses</param-name>
        <param-value>false</param-value>
    </context-param>
    <!-- Change load strategy to DEFAULT to disable sending scripts/styles as packs -->
    <context-param>
        <param-name>org.richfaces.resourceOptimization.enabled</param-name>
        <param-value>true</param-value>
    </context-param>

    <context-param>
        <param-name>org.richfaces.fileUpload.createTempFiles</param-name>
        <param-value>false</param-value>
    </context-param>

    <context-param>
        <param-name>org.richfaces.fileUpload.maxRequestSize</param-name>
        <param-value>100000000</param-value>
    </context-param>

    <!-- Seam -->

    <listener>
        <listener-class>org.jboss.seam.servlet.SeamListener</listener-class>
    </listener>
    <filter>
        <filter-name>Seam Filter</filter-name>
        <filter-class>org.jboss.seam.servlet.SeamFilter</filter-class>
        <init-param>
            <param-name>createTempFiles</param-name>
            <param-value>false</param-value>
        </init-param>
        <init-param>
            <param-name>maxRequestSize</param-name>
            <param-value>100000000</param-value>
        </init-param>
    </filter>
    <filter-mapping>
        <filter-name>Seam Filter</filter-name>
        <url-pattern>/*</url-pattern>
    </filter-mapping>
    <servlet>
        <servlet-name>Seam Resource Servlet</servlet-name>
        <servlet-class>org.jboss.seam.servlet.SeamResourceServlet</servlet-class>
    </servlet>
    <servlet-mapping>
        <servlet-name>Seam Resource Servlet</servlet-name>
        <url-pattern>/seam/resource/*</url-pattern>
    </servlet-mapping>
    <servlet>
        <servlet-name>Resource Servlet</servlet-name>
        <servlet-class>org.richfaces.webapp.ResourceServlet</servlet-class>
        <load-on-startup>1</load-on-startup>
    </servlet>
    <servlet-mapping>
        <servlet-name>Resource Servlet</servlet-name>
        <url-pattern>/org.richfaces.resources/*</url-pattern>
    </servlet-mapping>
    <!-- Facelets development mode (disable in production) -->
    <context-param>
        <param-name>facelets.DEVELOPMENT</param-name>
        <param-value>${seam.debug}</param-value>
    </context-param>

    <context-param>
        <param-name>org.richfaces.push.jms.enabled</param-name>
        <param-value>true</param-value>
    </context-param>

    <context-param>
        <param-name>javax.faces.FACELETS_SKIP_COMMENTS</param-name>
        <param-value>${facelets.skipcomments}</param-value>
    </context-param>
    <!-- JSF -->
    <context-param>
        <param-name>javax.faces.DEFAULT_SUFFIX</param-name>
        <param-value>.xhtml</param-value>
    </context-param>
    <servlet>
        <servlet-name>Faces Servlet</servlet-name>
        <servlet-class>javax.faces.webapp.FacesServlet</servlet-class>
        <load-on-startup>1</load-on-startup>
    </servlet>
    <servlet-mapping>
        <servlet-name>Faces Servlet</servlet-name>
        <url-pattern>*.seam</url-pattern>
    </servlet-mapping>
    <security-constraint>
        <display-name>Restrict raw XHTML Documents</display-name>
        <web-resource-collection>
            <web-resource-name>XHTML</web-resource-name>
            <url-pattern>*.xhtml</url-pattern>
        </web-resource-collection>
        <auth-constraint/>
    </security-constraint>
    <!-- uncomment <ejb-local-ref> entries when deploying to GlassFish and (optionally) JBoss AS 5 -->
    <!--
     <ejb-local-ref>
        <ejb-ref-name>SimulatorTemplate/AuthenticatorBean/local</ejb-ref-name>
        <ejb-ref-type>Session</ejb-ref-type>
        <local-home/>
        <local>com.mydomain.EssaiRich.action.Authenticator</local>
     </ejb-local-ref>
     -->
    <!-- Add entries for each EJB session bean which is also a Seam component (not required on JBoss AS) -->
    <!--   <persistence-unit-ref>-->
    <!--      <persistence-unit-ref-name>SimulatorTemplate/pu</persistence-unit-ref-name>-->
    <!--      <persistence-unit-name>../SimulatorTemplate.jar#SimulatorTemplate</persistence-unit-name>-->
    <!-- The relative reference doesn't work on GlassFish. Instead, set the <persistence-unit-name> to "SimulatorTemplate",
             package persistence.xml in the WAR, and add a <jar-file> element in persistence.xml with value "../../SimulatorTemplate.jar".
        <persistence-unit-name>SimulatorTemplate</persistence-unit-name>
        -->
    <!--   </persistence-unit-ref>-->

    <!-- CAS -->
    <context-param>
        <param-name>configurationStrategy</param-name>
        <param-value>PROPERTY_FILE</param-value>
    </context-param>

    <context-param>
        <param-name>configFileLocation</param-name>
        <param-value>/opt/gazelle/cas/XDStarClient.properties</param-value>
    </context-param>

    <filter>
        <filter-name>CookieBrowserFilter</filter-name>
        <filter-class>net.ihe.gazelle.common.servletfilter.CookieBrowserFilter</filter-class>
    </filter>
    <filter-mapping>
        <filter-name>CookieBrowserFilter</filter-name>
        <url-pattern>*.seam</url-pattern>
    </filter-mapping>

    <filter>
        <filter-name>CAS Single Sign Out Filter</filter-name>
        <filter-class>org.jasig.cas.client.session.SingleSignOutFilter</filter-class>
    </filter>
    <filter-mapping>
        <filter-name>CAS Single Sign Out Filter</filter-name>
        <url-pattern>/*</url-pattern>
    </filter-mapping>

    <listener>
        <listener-class>org.jasig.cas.client.session.SingleSignOutHttpSessionListener</listener-class>
    </listener>

    <filter>
        <filter-name>Gazelle CAS Authentication Filter</filter-name>
        <filter-class>net.ihe.gazelle.cas.client.authentication.AuthenticationFilter</filter-class>
    </filter>
    <filter-mapping>
        <filter-name>Gazelle CAS Authentication Filter</filter-name>
        <url-pattern>/login/login.seam</url-pattern>
    </filter-mapping>

    <filter>
        <filter-name>Gazelle Ip Authentication Filter</filter-name>
        <filter-class>net.ihe.gazelle.ssov7.authn.interlay.filter.IpAuthenticationFilter</filter-class>
    </filter>
    <filter-mapping>
        <filter-name>Gazelle Ip Authentication Filter</filter-name>
        <url-pattern>/login/ipLogin.seam</url-pattern>
    </filter-mapping>

    <filter>
        <filter-name>Gazelle CAS logout filter</filter-name>
        <filter-class>net.ihe.gazelle.cas.client.authentication.LogoutFilter</filter-class>
    </filter>
    <filter-mapping>
        <filter-name>Gazelle CAS logout filter</filter-name>
        <url-pattern>/cas/logout.seam</url-pattern>
    </filter-mapping>

    <filter>
        <filter-name>CAS Validation Filter</filter-name>
        <filter-class>org.jasig.cas.client.validation.Cas30ProxyReceivingTicketValidationFilter
        </filter-class>
    </filter>
    <filter-mapping>
        <filter-name>CAS Validation Filter</filter-name>
        <url-pattern>/*</url-pattern>
    </filter-mapping>

    <filter>
        <filter-name>CAS HttpServletRequest Wrapper Filter</filter-name>
        <filter-class>org.jasig.cas.client.util.HttpServletRequestWrapperFilter</filter-class>
    </filter>
    <filter-mapping>
        <filter-name>CAS HttpServletRequest Wrapper Filter</filter-name>
        <url-pattern>/*</url-pattern>
    </filter-mapping>

    <filter>
        <filter-name>ExpirationFilter</filter-name>
        <filter-class>net.ihe.gazelle.cas.client.authentication.SessionExpirationFilter</filter-class>
    </filter>
    <filter-mapping>
        <filter-name>ExpirationFilter</filter-name>
        <url-pattern>/*</url-pattern>
    </filter-mapping>

    <!-- resolving this error : http://old.nabble.com/Error:-Facelet-was-modified,-flushing-component-applied-td13500808.html -->
    <context-param>
        <param-name>javax.faces.FACELETS_REFRESH_PERIOD</param-name>
        <param-value>-1</param-value>
    </context-param>

    <!-- REST web service -->
    <context-param>
        <param-name>resteasy.jndi.resources</param-name>
        <param-value>java:app/mbval-documentation-ejb/AssertionWSProvider,java:app/metadata-v7/VersionControllerImpl,java:app/metadata-v7/MetadataServiceControllerImpl</param-value>
    </context-param>
    <context-param>
        <param-name>resteasy.servlet.mapping.prefix</param-name>
        <param-value>/rest</param-value>
    </context-param>
    <context-param>
        <param-name>resteasy.use.builtin.providers</param-name>
        <param-value>true</param-value>
    </context-param>
    <!-- resteasy -->
    <listener>
        <listener-class>org.jboss.resteasy.plugins.server.servlet.ResteasyBootstrap</listener-class>
    </listener>
    <servlet>
        <servlet-name>Resteasy</servlet-name>
        <servlet-class>org.jboss.resteasy.plugins.server.servlet.HttpServletDispatcher</servlet-class>
    </servlet>
    <servlet-mapping>
        <servlet-name>Resteasy</servlet-name>
        <url-pattern>/rest/*</url-pattern>
    </servlet-mapping>

    <context-param>
        <param-name>javax.faces.STATE_SAVING_METHOD</param-name>
        <param-value>server</param-value>
    </context-param>
</web-app>
